"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var namingService_1 = require("../../services/namingService");
var AppInsightsResource = /** @class */ (function () {
    function AppInsightsResource() {
    }
    AppInsightsResource.getResourceName = function (config) {
        return namingService_1.AzureNamingService.getResourceName(config, config.provider.appInsights, "appinsights");
    };
    AppInsightsResource.prototype.getTemplate = function () {
        return {
            "$schema": "https://schema.management.azure.com/schemas/2015-01-01/deploymentTemplate.json#",
            "contentVersion": "1.0.0.0",
            "parameters": {
                "appInsightsName": {
                    "defaultValue": "",
                    "type": "String"
                },
                "location": {
                    "defaultValue": "",
                    "type": "String"
                }
            },
            "variables": {},
            "resources": [
                {
                    "apiVersion": "2015-05-01",
                    "name": "[parameters('appInsightsName')]",
                    "type": "microsoft.insights/components",
                    "location": "[parameters('location')]",
                    "properties": {
                        "Application_Type": "web",
                        "ApplicationId": "[parameters('appInsightsName')]",
                        "Request_Source": "IbizaWebAppExtensionCreate"
                    }
                }
            ]
        };
    };
    AppInsightsResource.prototype.getParameters = function (config) {
        return {
            appInsightsName: AppInsightsResource.getResourceName(config),
        };
    };
    return AppInsightsResource;
}());
exports.AppInsightsResource = AppInsightsResource;
