"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = require("path");
var invokeService_1 = require("../../services/invokeService");
var azureBasePlugin_1 = require("../azureBasePlugin");
var AzureInvokePlugin = /** @class */ (function (_super) {
    __extends(AzureInvokePlugin, _super);
    function AzureInvokePlugin(serverless, options) {
        var _this = _super.call(this, serverless, options) || this;
        var path = _this.options["path"];
        if (path) {
            var absolutePath = path_1.isAbsolute(path)
                ? path
                : path_1.join(_this.serverless.config.servicePath, path);
            _this.log(_this.serverless.config.servicePath);
            _this.log(path);
            if (!fs_1.default.existsSync(absolutePath)) {
                throw new Error("The file you provided does not exist.");
            }
            _this.options["data"] = fs_1.default.readFileSync(absolutePath).toString();
        }
        _this.commands = {
            invoke: {
                usage: "Invoke command",
                lifecycleEvents: ["invoke"],
                options: {
                    resourceGroup: {
                        usage: "Resource group for the service",
                        shortcut: "g",
                    },
                    stage: {
                        usage: "Stage of service",
                        shortcut: "s"
                    },
                    region: {
                        usage: "Region of service",
                        shortcut: "r"
                    },
                    subscriptionId: {
                        usage: "Sets the Azure subscription ID",
                        shortcut: "i",
                    },
                    function: {
                        usage: "Function to call",
                        shortcut: "f",
                    },
                    path: {
                        usage: "Path to file to put in body",
                        shortcut: "p"
                    },
                    data: {
                        usage: "Data string for body of request",
                        shortcut: "d"
                    },
                    method: {
                        usage: "HTTP method (Default is GET)",
                        shortcut: "m"
                    }
                },
                commands: {
                    local: {
                        usage: "Invoke a local function",
                        options: {
                            function: {
                                usage: "Function to call",
                                shortcut: "f",
                            },
                            path: {
                                usage: "Path to file to put in body",
                                shortcut: "p"
                            },
                            data: {
                                usage: "Data string for body of request",
                                shortcut: "d"
                            },
                            method: {
                                usage: "HTTP method (Default is GET)",
                                shortcut: "m"
                            },
                            port: {
                                usage: "Port through which locally running service is exposed",
                                shortcut: "t"
                            }
                        },
                        lifecycleEvents: ["local"],
                    }
                }
            }
        };
        _this.hooks = {
            "invoke:invoke": _this.invokeRemote.bind(_this),
            "invoke:local:local": _this.invokeLocal.bind(_this),
        };
        return _this;
    }
    AzureInvokePlugin.prototype.invokeRemote = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.invoke()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AzureInvokePlugin.prototype.invokeLocal = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.invoke(true)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AzureInvokePlugin.prototype.invoke = function (local) {
        if (local === void 0) { local = false; }
        return __awaiter(this, void 0, void 0, function () {
            var functionName, data, method, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        functionName = this.options["function"];
                        data = this.options["data"];
                        method = this.options["method"] || "GET";
                        if (!functionName) {
                            this.log("Need to provide a name of function to invoke");
                            return [2 /*return*/];
                        }
                        this.invokeService = new invokeService_1.InvokeService(this.serverless, this.options, local);
                        return [4 /*yield*/, this.invokeService.invoke(method, functionName, data)];
                    case 1:
                        response = _a.sent();
                        if (response) {
                            this.log(JSON.stringify(response.data));
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return AzureInvokePlugin;
}(azureBasePlugin_1.AzureBasePlugin));
exports.AzureInvokePlugin = AzureInvokePlugin;
